import React from 'react'
import { grommet, Grommet, Box, Button, Heading, Text, Paragraph, AccordionPanel, Accordion } from 'grommet'
import { Previous } from 'grommet-icons'

import type { Geo, Address, Company, User } from './Users'
import { users } from './Users'

const App = () => {

    return (
        <Grommet full theme={grommet}>
            <Box align="center" justify="center" pad="small" background={{ "color": "accent-4", "image": "url('https://blog.hdwallsource.com/wp-content/uploads/2014/11/gradient-26052-26737-hd-wallpapers.jpg.png')" }} height="xlarge" flex={false} fill="vertical" direction="row" wrap overflow="auto">
                {users.map(({ name, email, company, address }: User) =>
                    <Box background={{ "color": "white" }} round="medium" margin="medium">
                        <Box align="start" justify="start" pad="small" direction="row" alignSelf="start">
                            <Button icon={<Previous />} primary color="brand" hoverIndicator={false} disabled={false} reverse={false} />
                        </Box>
                        <Box align="center" justify="center" pad="xsmall" margin="xsmall">
                            <Box align="center" justify="center" pad="large" margin="medium" background={{ "dark": false, "color": "light-2", "image": "url('https://avatars0.githubusercontent.com/u/1753301?s=460&v=4\n')" }} round="full" />
                            <Heading level="2" size="medium" margin="xsmall" textAlign="center">
                                {name}
                            </Heading>
                            <Text textAlign="center" size="medium" weight="bold">
                                {email}
                            </Text>
                            <Paragraph size="small" margin="medium" textAlign="center">
                                {company.catchPhrase}
                            </Paragraph>
                            <Accordion>
                                <AccordionPanel label="Address">
                                    <Text>
                                        {address.street}
                                    </Text>
                                    <Text>
                                        {address.zipcode}
                                    </Text>
                                    <Text>
                                        {address.city}
                                    </Text>
                                </AccordionPanel>
                            </Accordion>
                            <Box align="center" justify="center" pad="small" direction="row-responsive" flex alignSelf="center" basis="xxsmall" gap="small" margin="xsmall">
                                <Button label="Portfolio" plain={false} primary />
                                <Button label="Hire Me" />
                            </Box>
                        </Box>
                    </Box>
                )}
            </Box>
        </Grommet>
    )
}

export default App;