type Geo = {
    readonly lat: string;
    readonly lng: string;
}

type Address = {
    readonly street: string;
    readonly suite: string;
    readonly city: string;
    readonly zipcode: string;
    readonly geo: Geo;
}

type Company = {
    readonly name: string;
    readonly catchPhrase: string;
    readonly bs: string;
}

type User = {
    readonly id: number;
    readonly name: string;
    readonly username: string;
    readonly email: string;
    readonly address: Address;
    readonly phone: string;
    readonly website: string;
    readonly company: Company;
}

const users: readonly User[] = [
    {
        id: 1,
        name: 'Leanne Graham',
        username: 'Bret',
        email: 'Sincere@april.biz',
        address: {
            street: 'Kulas Light',
            suite: 'Apt. 556',
            city: 'Gwenborough',
            zipcode: '92998-3874',
            geo: { lat: '-37.3159', lng: '81.1496' }
        },
        phone: '1-770-736-8031 x56442',
        website: 'hildegard.org',
        company: {
            name: 'Romaguera-Crona',
            catchPhrase: 'Multi-layered client-server neural-net',
            bs: 'harness real-time e-markets'
        }
    },
    {
        id: 2,
        name: 'Ervin Howell',
        username: 'Antonette',
        email: 'Shanna@melissa.tv',
        address: {
            street: 'Victor Plains',
            suite: 'Suite 879',
            city: 'Wisokyburgh',
            zipcode: '90566-7771',
            geo: { lat: '-43.9509', lng: '-34.4618' }
        },
        phone: '010-692-6593 x09125',
        website: 'anastasia.net',
        company: {
            name: 'Deckow-Crist',
            catchPhrase: 'Proactive didactic contingency',
            bs: 'synergize scalable supply-chains'
        }
    },
    {
        id: 3,
        name: 'Clementine Bauch',
        username: 'Samantha',
        email: 'Nathan@yesenia.net',
        address: {
            street: 'Douglas Extension',
            suite: 'Suite 847',
            city: 'McKenziehaven',
            zipcode: '59590-4157',
            geo: { lat: '-68.6102', lng: '-47.0653' }
        },
        phone: '1-463-123-4447',
        website: 'ramiro.info',
        company: {
            name: 'Romaguera-Jacobson',
            catchPhrase: 'Face to face bifurcated interface',
            bs: 'e-enable strategic applications'
        }
    },
    {
        id: 4,
        name: 'Patricia Lebsack',
        username: 'Karianne',
        email: 'Julianne.OConner@kory.org',
        address: {
            street: 'Hoeger Mall',
            suite: 'Apt. 692',
            city: 'South Elvis',
            zipcode: '53919-4257',
            geo: { lat: '29.4572', lng: '-164.2990' }
        },
        phone: '493-170-9623 x156',
        website: 'kale.biz',
        company: {
            name: 'Robel-Corkery',
            catchPhrase: 'Multi-tiered zero tolerance productivity',
            bs: 'transition cutting-edge web services'
        }
    },
    {
        id: 5,
        name: 'Chelsey Dietrich',
        username: 'Kamren',
        email: 'Lucio_Hettinger@annie.ca',
        address: {
            street: 'Skiles Walks',
            suite: 'Suite 351',
            city: 'Roscoeview',
            zipcode: '33263',
            geo: { lat: '-31.8129', lng: '62.5342' }
        },
        phone: '(254)954-1289',
        website: 'demarco.info',
        company: {
            name: 'Keebler LLC',
            catchPhrase: 'User-centric fault-tolerant solution',
            bs: 'revolutionize end-to-end systems'
        }
    },
    {
        id: 6,
        name: 'Mrs. Dennis Schulist',
        username: 'Leopoldo_Corkery',
        email: 'Karley_Dach@jasper.info',
        address: {
            street: 'Norberto Crossing',
            suite: 'Apt. 950',
            city: 'South Christy',
            zipcode: '23505-1337',
            geo: { lat: '-71.4197', lng: '71.7478' }
        },
        phone: '1-477-935-8478 x6430',
        website: 'ola.org',
        company: {
            name: 'Considine-Lockman',
            catchPhrase: 'Synchronised bottom-line interface',
            bs: 'e-enable innovative applications'
        }
    },
    {
        id: 7,
        name: 'Kurtis Weissnat',
        username: 'Elwyn.Skiles',
        email: 'Telly.Hoeger@billy.biz',
        address: {
            street: 'Rex Trail',
            suite: 'Suite 280',
            city: 'Howemouth',
            zipcode: '58804-1099',
            geo: { lat: '24.8918', lng: '21.8984' }
        },
        phone: '210.067.6132',
        website: 'elvis.io',
        company: {
            name: 'Johns Group',
            catchPhrase: 'Configurable multimedia task-force',
            bs: 'generate enterprise e-tailers'
        }
    },
    {
        id: 8,
        name: 'Nicholas Runolfsdottir V',
        username: 'Maxime_Nienow',
        email: 'Sherwood@rosamond.me',
        address: {
            street: 'Ellsworth Summit',
            suite: 'Suite 729',
            city: 'Aliyaview',
            zipcode: '45169',
            geo: { lat: '-14.3990', lng: '-120.7677' }
        },
        phone: '586.493.6943 x140',
        website: 'jacynthe.com',
        company: {
            name: 'Abernathy Group',
            catchPhrase: 'Implemented secondary concept',
            bs: 'e-enable extensible e-tailers'
        }
    },
    {
        id: 9,
        name: 'Glenna Reichert',
        username: 'Delphine',
        email: 'Chaim_McDermott@dana.io',
        address: {
            street: 'Dayna Park',
            suite: 'Suite 449',
            city: 'Bartholomebury',
            zipcode: '76495-3109',
            geo: { lat: '24.6463', lng: '-168.8889' }
        },
        phone: '(775)976-6794 x41206',
        website: 'conrad.com',
        company: {
            name: 'Yost and Sons',
            catchPhrase: 'Switchable contextually-based project',
            bs: 'aggregate real-time technologies'
        }
    },
    {
        id: 10,
        name: 'Clementina DuBuque',
        username: 'Moriah.Stanton',
        email: 'Rey.Padberg@karina.biz',
        address: {
            street: 'Kattie Turnpike',
            suite: 'Suite 198',
            city: 'Lebsackbury',
            zipcode: '31428-2261',
            geo: { lat: '-38.2386', lng: '57.2232' }
        },
        phone: '024-648-3804',
        website: 'ambrose.net',
        company: {
            name: 'Hoeger LLC',
            catchPhrase: 'Centralized empowering task-force',
            bs: 'target end-to-end models'
        }
    }
]

// to fully display the value
console.dir(users, { depth: null });

// Question 1
function allCompanies(users: readonly User[]): readonly Company[] {
    return users.map((user: User) => user.company);
}

console.log(allCompanies(users));

// Question 2
function allCompanyNames(users: readonly User[]): readonly string[] {
    return users.map((user: User) => user.company.name);
}

console.log(allCompanyNames(users));

// Question 3
function allAddresses(users: readonly User[]): readonly Address[] {
    return users.map((user: User) => user.address);
}

console.log(allAddresses(users));

// Question 4
function allCities(users: readonly User[]): readonly string[] {
    return users.map((user: User) => user.address.city);
}

console.log(allCities(users));

// Question 5
function cityStartsWithS(address: Address): boolean {
    return address.city.startsWith("S");
}

// Question 6
function addressesWithS(addresses: readonly Address[]): readonly Address[] {
    return addresses.filter(cityStartsWithS);
}

console.log(addressesWithS(allAddresses(users)));

// Question 7
function usersWithOrg(user: User): boolean {
    return user.website.endsWith(".org");
}

// Question 12
function addressesCityUC(addresses: readonly Address[]): readonly Address[] {
    return addresses.map((address: Address) => ({ ...address, city: address.city.toUpperCase() }));
}

// Question 14
function cmpString(s1: string, s2: string): (1 | 0 | -1) {
    if (s1 > s2)
        return 1;
    if (s2 > s1)
        return -1;
    else
        return 0;
}

// Question 15
function cmpCities(address1: Address, address2: Address): (1 | 0 | -1) {
    return cmpString(address1.city, address2.city);
}

// Question 16
function addressesSorted(addresses: readonly Address[]): readonly Address[] {
    return [...addresses].sort(cmpCities);
}

console.log(addressesSorted(allAddresses(users)));

// Question 20
function maxLatitude(addresses: readonly Address[]): number {
    return addresses.reduce((x:number,y:Address) => Math.max(x, parseFloat(y.geo.lat)), 0.0);
}

console.log(maxLatitude(allAddresses(users)));

//function averageLatitude(addresses: readonly Address[]): number

export type { Geo, Address, Company, User }
export { users }